# -*- coding: utf-8 -*-
from setuphelpers import *
import platform

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_x86 = 'zulu8.46.0.19-ca-jre8.0.252-win_i686.msi'
bin_name_x64 = 'zulu8.46.0.19-ca-jre8.0.252-win_x64.msi'
url_dl_x64 = 'https://cdn.azul.com/zulu/bin/zulu8.46.0.19-ca-jre8.0.252-win_x64.msi'
url_dl_x86 = 'https://cdn.azul.com/zulu/bin/zulu8.46.0.19-ca-jre8.0.252-win_i686.msi'


def install():
    # Initializing variables
    package_version = control.version.split('-')[0]

    # Uninstalling older versions
    check_installed = installed_softwares(name='Zulu JRE')
    for uninstall_app in check_installed:
        if 'Azul Systems, Inc.' in uninstall_app['publisher']:
            if uninstall_app['version'] < package_version:
                    print('Removing: %s'% uninstall_app['name'])
                    run(uninstall_cmd(uninstall_app['key']))

    # Installing package
    print('Installing: ' + bin_name_x86)
    install_msi_if_needed(bin_name_x86)

    if iswin64():
        print('Installing: ' + bin_name_x64)
        install_msi_if_needed(bin_name_x64)


def update_package():
    print('Download/Update package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system()=='Windows' and isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    latest_bin_x64 = bin_name_x64
    latest_bin_x86 = bin_name_x86

    # Downloading latest binaries
    if not isfile(latest_bin_x64):
        print('Downloading ' + latest_bin_x64)
        wget(url_dl_x64,latest_bin_x64,proxies=proxy)
    if not isfile(latest_bin_x86):
        print('Downloading ' + latest_bin_x86)
        wget(url_dl_x86,latest_bin_x86,proxies=proxy)

        version = get_msi_properties(latest_bin_x86)['ProductVersion']

        # Changing version of the package
        control.version = '%s-%s'%(version,int(control.version.split('-')[-1])+1)
        control.save_control_to_wapt()
        print('Changing version to: %s in WAPT\\control' % control.version)

    # Deleting outdated binaries
    for bin_in_dir in glob.glob('*.exe') or glob.glob('*.msi') or glob.glob('*.zip'):
        if bin_in_dir != latest_bin_x86 and bin_in_dir != latest_bin_x64:
            print('Outdated binary: ' + bin_in_dir + ' Deleted')
            remove_file(bin_in_dir)



